//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXTreeView.h
 * @brief		TreeView NX t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef _IRIS_WXTreeView_H_
#define _IRIS_WXTreeView_H_

//======================================================================
// include
#include "WXSubClass.h"
#include <commctrl.h>

namespace iris {
namespace wx
{

//======================================================================
// class
/**
 * @brief	c[r[NX
*/
class CTreeView : public CSubClass
{
public:
	// RXgN^
	CTreeView(void);
	CTreeView(HWND hWnd);
	// fXgN^
	~CTreeView(void);
public:
    // EBhE̍쐬
    virtual HWND Create(DWORD dwStyle
					 , const RECT &rRect
					 , HWND hWndParent, UINT nID
					 , HINSTANCE hInstance
					 , void *pParam = nullptr );
    virtual HWND Create(DWORD dwStyle
					 , int x, int y, int w, int h
					 , HWND hWndParent, UINT nID
					 , HINSTANCE hInstance
					 , void *pParam = nullptr );
    // EBhE̍쐬
    virtual HWND CreateEx(DWORD dwExStyle
					 , DWORD dwStyle
					 , const RECT &rRect
					 , HWND hWndParent, UINT nID
					 , HINSTANCE hInstance
					 , void *pParam = nullptr );
    virtual HWND CreateEx(DWORD dwExStyle
					 , DWORD dwStyle
					 , int x, int y, int w, int h
					 , HWND hWndParent, UINT nID
					 , HINSTANCE hInstance
					 , void *pParam = nullptr );

public:
	// wrap
	// ACe̒ǉ
	HTREEITEM	InsertItem(LPTV_INSERTSTRUCT lpis);
};
	
}	// end of namespace wx
}	// end of namespace iris

#endif
