//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXGdiFont.h
 * @brief		GDItHgIuWFNgNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2010 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef _IRIS_WXGdiFont_H_
#define _IRIS_WXGdiFont_H_

//======================================================================
// include
#include "WXGdiObject.h"

namespace iris {
namespace wx
{

//======================================================================
// class
//! GDIyIuWFNgNX
class CGDIFont : public CGDIObjectBase<HFONT>
{
	typedef CGDIObjectBase<HFONT>	_Base;
public:
	// RXgN^
	CGDIFont(void)	{}

#ifdef STRICT
	// ^̌ɑΉ
	/// RXgN^
	CGDIFont(HGDIOBJ hObj) : _Base(static_cast<_MyObj>(hObj)) 		{}
				operator	HGDIOBJ (void)		{ return static_cast<HGDIOBJ>(GetObject()); }
	CGDIFont&	operator	= (HGDIOBJ hObj)	{ Attach(static_cast<_MyObj>(hObj)); return *this; }
#endif

public:
	// tHg̍쐬
	BOOL	Create (int nHeight, int nWidth, int nEscapement, int nOrientation, int nWeight
					, DWORD bItalic, DWORD bUnderline, DWORD bStrikeOut
					, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision
					, DWORD iQuality, DWORD iPitchAndFamily, LPCTSTR pszFaceName);
	BOOL	CreateA(int nHeight, int nWidth, int nEscapement, int nOrientation, int nWeight
					, DWORD bItalic, DWORD bUnderline, DWORD bStrikeOut
					, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision
					, DWORD iQuality, DWORD iPitchAndFamily, LPCSTR  pszFaceName);
	BOOL	CreateW(int nHeight, int nWidth, int nEscapement, int nOrientation, int nWeight
					, DWORD bItalic, DWORD bUnderline, DWORD bStrikeOut
					, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision
					, DWORD iQuality, DWORD iPitchAndFamily, LPCWSTR pszFaceName);
	// tHg̍쐬
	BOOL	CreateIndirect (const LOGFONT*  lplf);
	BOOL	CreateIndirectA(const LOGFONTA* lplf);
	BOOL	CreateIndirectW(const LOGFONTW* lplf);

};

}	// end of namespace wx
}	// end of namespace iris

#endif
